"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.CliProgressTaskPoolExecutor = void 0;
var ansi_colors_1 = __importDefault(require("ansi-colors"));
var cli_progress_1 = require("cli-progress");
var simple_task_pool_executor_1 = require("./simple-task-pool-executor");
var CliProgressTaskPoolExecutor = (function (_super) {
    __extends(CliProgressTaskPoolExecutor, _super);
    function CliProgressTaskPoolExecutor(props) {
        var _this = _super.call(this, props) || this;
        _this.poolProgress = new cli_progress_1.MultiBar({
            format: ansi_colors_1["default"].redBright('{bar}') +
                ' {percentage}% | {title} | {info}',
            clearOnComplete: props.clearOnComplete,
            hideCursor: props.hideCursor
        }, cli_progress_1.Presets.rect);
        _this.bars = new Map();
        return _this;
    }
    CliProgressTaskPoolExecutor.prototype._execute = function (taskId, runnable) {
        var progress = this.poolProgress.create(100, 0, {
            title: runnable.title,
            info: ''
        });
        this.bars.set(taskId, progress);
        return _super.prototype._execute.call(this, taskId, runnable, { progress: progress });
    };
    CliProgressTaskPoolExecutor.prototype._release = function (taskId) {
        var progress = this.bars.get(taskId);
        if (progress) {
            progress.update(100);
        }
        _super.prototype._release.call(this, taskId);
    };
    CliProgressTaskPoolExecutor.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                result = _super.prototype.close.call(this);
                this.poolProgress.stop();
                return [2, result];
            });
        });
    };
    return CliProgressTaskPoolExecutor;
}(simple_task_pool_executor_1.SimpleTaskPoolExecutor));
exports.CliProgressTaskPoolExecutor = CliProgressTaskPoolExecutor;
